import * as react_jsx_runtime from 'react/jsx-runtime';
import * as React from 'react';
import React__default, { ReactNode, SyntheticEvent, CSSProperties, Ref, RefObject, JSXElementConstructor, MutableRefObject, ReactElement as ReactElement$1 } from 'react';

declare function ReactBulk({ theme: themeProp, children }: any): react_jsx_runtime.JSX.Element;

/************
 * Box Size *
 ************/
declare const boxSizeProps: readonly ["width", "height", "maxWidth", "maxHeight", "w", "h", "maxw", "maxh", "minw", "minh", "ww", "hh"];
/***********
 * Flexbox *
 ***********/
declare const flexContainerAlignProps: readonly ["placeContent", "placeItems", "alignContent", "alignItems", "justifyContent", "justifyItems", "center"];
declare const flexChildAlignProps: readonly ["placeSelf", "alignSelf", "justifySelf", "align", "justify"];
declare const flexAlignProps: readonly ["placeContent", "placeItems", "alignContent", "alignItems", "justifyContent", "justifyItems", "center", "placeSelf", "alignSelf", "justifySelf", "align", "justify"];
declare const flexContainerProps: readonly ["flexDirection", "flexFlow", "flexWrap", "placeContent", "placeItems", "alignContent", "alignItems", "justifyContent", "justifyItems", "center", "direction", "row", "column", "reverse", "wrap", "noWrap"];
declare const flexChildProps: readonly ["flex", "flexBasis", "flexGrow", "flexShrink", "order", "placeSelf", "alignSelf", "justifySelf", "align", "justify", "grow", "shrink", "basis"];
declare const flexProps: ("placeContent" | "placeItems" | "alignContent" | "alignItems" | "justifyContent" | "justifyItems" | "center" | "placeSelf" | "alignSelf" | "justifySelf" | "align" | "justify" | "flexDirection" | "flexFlow" | "flexWrap" | "direction" | "row" | "column" | "reverse" | "wrap" | "noWrap" | "flex" | "flexBasis" | "flexGrow" | "flexShrink" | "order" | "grow" | "shrink" | "basis")[];
/************
 * Spacings *
 ************/
declare const customSpacings: readonly ["i", "t", "b", "l", "r", "m", "mt", "mb", "ml", "mr", "mh", "mx", "mv", "my", "p", "pt", "pb", "pl", "pr", "ph", "px", "pv", "py", "g", "gx", "gy"];
declare const customStyleProps: readonly ["bg", "border", "borderBottom", "borderLeft", "borderRight", "borderTop", "corners", "direction", "h", "lh", "ls", "maxh", "maxw", "minh", "minw", "position", "shadow", "w", "i", "t", "b", "l", "r", "m", "mt", "mb", "ml", "mr", "mh", "mx", "mv", "my", "p", "pt", "pb", "pl", "pr", "ph", "px", "pv", "py", "g", "gx", "gy"];
declare const gapSpacings: readonly ["gap", "rowGap", "columnGap"];
declare const spacings: readonly ["position", "top", "bottom", "left", "right", "margin", "marginTop", "marginBottom", "marginLeft", "marginRight", "marginHorizontal", "marginVertical", "padding", "paddingTop", "paddingBottom", "paddingLeft", "paddingRight", "paddingHorizontal", "paddingVertical", "gap", "rowGap", "columnGap", "i", "t", "b", "l", "r", "m", "mt", "mb", "ml", "mr", "mh", "mx", "mv", "my", "p", "pt", "pb", "pl", "pr", "ph", "px", "pv", "py", "g", "gx", "gy"];
declare const transformProps: readonly ["matrix", "perspective", "rotate", "rotateX", "rotateY", "rotateZ", "scale", "scaleX", "scaleY", "translateX", "translateY", "skewX", "skewY"];
declare const notPxProps: readonly ["animationIterationCount", "aspectRatio", "borderImageOutset", "borderImageSlice", "borderImageWidth", "boxFlex", "boxFlexGroup", "boxOrdinalGroup", "columnCount", "columns", "fillOpacity", "flex", "flexGrow", "flexNegative", "flexOrder", "flexPositive", "flexShrink", "floodOpacity", "fontWeight", "gridArea", "gridColumn", "gridColumnEnd", "gridColumnSpan", "gridColumnStart", "gridRow", "gridRowEnd", "gridRowSpan", "gridRowStart", "lineClamp", "lineHeight", "opacity", "order", "orphans", "rotate", "scale", "stopOpacity", "strokeDasharray", "strokeDashoffset", "strokeMiterlimit", "strokeOpacity", "strokeWidth", "tabSize", "transform", "widows", "zIndex", "zoom"];
/************************
 * All Supported Styles *
 ************************/
declare const styleProps: readonly ["width", "height", "maxWidth", "maxHeight", "w", "h", "maxw", "maxh", "minw", "minh", "ww", "hh", ...("placeContent" | "placeItems" | "alignContent" | "alignItems" | "justifyContent" | "justifyItems" | "center" | "placeSelf" | "alignSelf" | "justifySelf" | "align" | "justify" | "flexDirection" | "flexFlow" | "flexWrap" | "direction" | "row" | "column" | "reverse" | "wrap" | "noWrap" | "flex" | "flexBasis" | "flexGrow" | "flexShrink" | "order" | "grow" | "shrink" | "basis")[], "position", "top", "bottom", "left", "right", "margin", "marginTop", "marginBottom", "marginLeft", "marginRight", "marginHorizontal", "marginVertical", "padding", "paddingTop", "paddingBottom", "paddingLeft", "paddingRight", "paddingHorizontal", "paddingVertical", "gap", "rowGap", "columnGap", "i", "t", "b", "l", "r", "m", "mt", "mb", "ml", "mr", "mh", "mx", "mv", "my", "p", "pt", "pb", "pl", "pr", "ph", "px", "pv", "py", "g", "gx", "gy", "bg", "border", "borderBottom", "borderLeft", "borderRight", "borderTop", "corners", "direction", "h", "lh", "ls", "maxh", "maxw", "minh", "minw", "position", "shadow", "w", "i", "t", "b", "l", "r", "m", "mt", "mb", "ml", "mr", "mh", "mx", "mv", "my", "p", "pt", "pb", "pl", "pr", "ph", "px", "pv", "py", "g", "gx", "gy", "aspectRatio", "backfaceVisibility", "backgroundColor", "borderBottomColor", "borderBottomEndRadius", "borderBottomLeftRadius", "borderBottomRightRadius", "borderBottomStartRadius", "borderBottomWidth", "borderColor", "borderEndColor", "borderEndWidth", "borderLeftColor", "borderLeftWidth", "borderRadius", "borderRightColor", "borderRightWidth", "borderStartColor", "borderStartWidth", "borderStyle", "borderTopColor", "borderTopEndRadius", "borderTopLeftRadius", "borderTopRightRadius", "borderTopStartRadius", "borderTopWidth", "borderWidth", "boxShadow", "color", "direction", "display", "fontFamily", "fontSize", "fontStyle", "fontVariant", "fontWeight", "letterSpacing", "lineHeight", "opacity", "overflow", "pointerEvents", "textAlign", "textTransform", "transform", "zIndex"];
declare const aliases: {
    w: string;
    h: string;
    maxw: string;
    maxh: string;
    minw: string;
    minh: string;
    lh: string;
    ls: string;
    bg: string;
    direction: string;
    grow: string;
    shrink: string;
    basis: string;
    align: string;
    justify: string;
};

type ReactElement = ReactNode | ReactNode[] | JSX.Element | JSX.Element[];
type ReactOnlyElement = ReactNode | JSX.Element;
type AnyObject = {
    [key: PropertyKey]: any;
};
type TimeoutType = ReturnType<typeof setTimeout> | null;
type IntervalType = ReturnType<typeof setInterval> | null;
type InputValue = any;
type Prettify<T> = {
    [K in keyof T]: T[K];
};
type DistributiveOmit<T, K extends PropertyKey> = T extends any ? Omit<T, K> : never;
type Overwrite<T, NewT> = DistributiveOmit<T, keyof NewT> & NewT;
type RecursivePartial<T> = {
    [P in keyof T]?: T[P] extends (infer U)[] ? RecursivePartial<U>[] : T[P] extends object | undefined ? RecursivePartial<T[P]> : T[P];
};
/** @internal */
type StyleValue = undefined | null | false | AnyObject | (CSSProperties & StyleProps);
/** @internal */
type RequiredSome<T, K extends keyof T> = Partial<T> & Required<Pick<T, K>>;
/** @internal */
type PropsWithStyles<ALLOW_ANY, T1, T2 = {}> = Overwrite<BaseProps, Overwrite<T1, T2>> & (ALLOW_ANY extends true ? {
    [key: string | number]: any;
} : {});
/** @internal */
type ColorTypographyToken = 'text' | 'background';
/** @internal */
type ColorTypographyTone = 'primary' | 'secondary' | 'tertiary' | 'disabled';
/** @internal */
type ColorToken = 'primary' | 'secondary' | 'info' | 'success' | 'warning' | 'error';
/** @internal */
type ColorTone = 'main' | 'light' | 'lighter' | 'dark' | 'darker' | 'contrast';
/** @internal */
type CSSFlexJustify = 'center' | 'stretch' | 'flex-start' | 'flex-end' | 'space-between' | 'space-around' | 'space-evenly' | 'start' | 'end' | 'between' | 'around' | 'evenly';
/** @internal */
type CSSFlexAlign = 'flex-start' | 'flex-end' | 'center' | 'stretch' | 'start' | 'end';
/** @internal */
type StyleProps = Overwrite<Overwrite<{
    [K in (typeof styleProps)[number]]?: any;
}, {
    [K in (typeof customSpacings)[number]]?: number | string | true;
}>, {
    position?: 'relative' | 'absolute' | (string & {});
    transform?: {
        [key in (typeof transformProps)[number]]?: any;
    };
    direction?: 'row' | 'row-reverse' | 'column' | 'column-reverse';
    justifyContent?: CSSFlexJustify;
    alignContent?: CSSFlexAlign;
    justifyItems?: CSSFlexJustify;
    alignItems?: CSSFlexAlign | 'baseline';
    order?: number;
    grow?: number;
    shrink?: number;
    basis?: 'auto' | (string & {}) | (number & {});
    align?: CSSFlexAlign;
    justify?: CSSFlexJustify;
    h?: number | string | true;
    w?: number | string | true;
    minw?: number | string | true;
    maxw?: number | string | true;
    minh?: number | string | true;
    maxh?: number | string | true;
    hh?: number | string | true;
    ww?: number | string | true;
    bg?: RbkColor;
    border?: RbkColor | string | number | boolean;
    corners?: number;
    shadow?: number;
}>;
/** @internal */
type SelectOption = {
    value: InputValue;
    disabled?: boolean;
    [key: string]: any;
} & ({
    label: string;
    searchLabel?: string;
} | {
    label: ReactElement;
    searchLabel: string;
});
/** @internal */
type TableColumn<RowData = any> = {
    header?: ReactElement | ((column: TableColumn<RowData>) => ReactElement);
    content?: ReactElement | ((row: RowData) => ReactElement);
    style?: RbkStyle;
};
/** @internal */
type TabItem = Overwrite<DistributiveOmit<ButtonProps, 'children'>, {
    label: string;
    value?: string | number;
}>;
/** @internal */
type FormField = {
    name: string;
    initialValue?: any;
    get: () => InputValue | null | undefined;
    set: (value: InputValue) => any;
    getError?: () => string | boolean | null | undefined;
    setError?: (error: string | boolean | null | undefined) => any;
    onFormChange?: (event: RbkFormEvent, data: AnyObject) => any;
};
type FormRef = {
    initialData: AnyObject | undefined;
    cancel: () => any;
    reset: () => any;
    clear: () => any;
    getData: () => AnyObject;
    setData: (data: AnyObject) => any;
    getErrors: () => null | AnyObject;
    setErrors: (errors: FormProps['errors']) => any;
    getValue: (name: string) => InputValue | undefined;
    setValue: (name: string, value: InputValue) => any;
    submit: () => any;
    target: ReactElement;
    getField: (name: string) => FormField | null | undefined;
    setField: (options: FormField) => any;
    unsetField: (name: string) => any;
};
type RbkMap = {
    web: boolean;
    native: boolean;
    ios: boolean;
    android: boolean;
    useDimensions: () => {
        width: number;
        height: number;
    };
    dimensions: {
        window: () => {
            width: number;
            height: number;
        };
    };
    svg: {
        [key: string]: ReactElement;
    };
    [key: string]: ReactElement | any;
};
type RbkBreakpoints = {
    xs: number;
    sm: number;
    md: number;
    lg: number;
    xl: number;
    xxl: number;
    [key: string]: number;
};
type RbkUnit = `${number}px` | `${number}%` | `${number}rem` | `${number}vw` | `${number}vh` | `${number}gap` | (number & {}) | (string & {});
type RbkSize = 'xsmall' | 'small' | 'medium' | 'large' | 'xlarge' | (number & {});
type RbkColor = ColorTypographyToken | ColorToken | `${ColorTypographyToken}.${ColorTypographyTone}` | `${ColorToken}.${ColorTone}` | `${ColorTypographyToken}.${ColorTypographyTone}.${number}` | `${ColorToken}.${ColorTone}.${number}` | (string & {});
type RbkRect = {
    width: number;
    height: number;
    /** Left offset relative to the Document */
    offsetX: number;
    /** Top offset relative to the Document */
    offsetY: number;
    /** Left offset relative to the Window */
    pageOffsetX: number;
    /** Top offset relative to the Window */
    pageOffsetY: number;
};
type RbkAnimation = {
    to: RbkStyleProps;
    from?: RbkStyleProps;
    boomerang?: boolean;
    delay?: number;
    duration?: number;
    iterations?: number | 'infinite';
    throttle?: number;
    timing?: 'linear' | 'ease' | 'ease-in' | 'ease-out' | 'ease-in-out';
    web_useRawStyle?: boolean;
};
type RbkTouch = {
    identifier: number;
    offsetX: number;
    offsetY: number;
    pageX: number;
    pageY: number;
};
type RbkEvent<EventType = any, TargetType = any> = {
    type: string;
    handler: 'RbkEvent';
    target: TargetType;
    currentTarget: TargetType;
    timestamp: number;
    nativeEvent: EventType;
    preventDefault: () => void;
    stopPropagation: () => void;
};
type RbkKeyboardEvent<EventType = any, TargetType = any> = Overwrite<RbkEvent<EventType, TargetType>, {
    handler: 'RbkKeyboardEvent';
    key: string;
    code: string;
    keyCode: number;
    altKey: boolean;
    ctrlKey: boolean;
    metaKey: boolean;
    shiftKey: boolean;
}>;
type RbkPointerEvent<EventType = any, TargetType = any> = Overwrite<RbkEvent<EventType, TargetType>, {
    handler: 'RbkPointerEvent';
    /**
     * The X position of the touch, relative to the element
     */
    offsetX: number;
    /**
     * The Y position of the touch, relative to the element
     */
    offsetY: number;
    /**
     * The X position of the touch, relative to the screen
     */
    pageX: number;
    /**
     * The Y position of the touch, relative to the screen
     */
    pageY: number;
    touches: RbkTouch[];
}>;
type RbkScrollEvent<EventType = any, TargetType = any> = Overwrite<RbkEvent<EventType, TargetType>, {
    handler: 'RbkScrollEvent';
    width: number;
    height: number;
    contentWidth: number;
    contentHeight: number;
    offsetX: number;
    offsetY: number;
    contentInset?: {
        top: RbkUnit;
        bottom: RbkUnit;
        left: RbkUnit;
        right: RbkUnit;
    };
}>;
type RbkInputEvent = Overwrite<RbkEvent, {
    handler: 'RbkInputEvent';
    value: InputValue;
    name?: string;
    form?: FormRef;
    focus: () => void;
    blur: () => void;
    clear: () => void;
    reset: () => void;
    isFocused: () => boolean;
}>;
type RbkFormEvent = {
    type: string;
    name?: string;
    form: FormRef;
    target: ReactOnlyElement;
    nativeEvent?: Event | SyntheticEvent;
};
type RbkStyle = StyleValue | StyleValue[];
type RbkStyleProps = Overwrite<CSSProperties, StyleProps>;
type ThemeModeValues = 'light' | 'dark';
type ThemeColorsProps = {
    main?: string;
    light?: string;
    lighter?: string;
    dark?: string;
    darker?: string;
} | (string & {});
type ThemeComponentProps<Props extends AnyObject> = Prettify<{
    name: string;
    defaultProps: Partial<Props>;
    defaultStyles: {
        root: RbkStyle;
    } & {
        [key in keyof NonNullable<Props['variants']>]: RbkStyle;
    };
    variants: {
        [prop: string]: {
            [value: string]: {
                root?: RbkStyle;
            } & {
                [key in keyof NonNullable<Props['variants']>]?: RbkStyle;
            };
        };
    };
}>;
type ThemeProps = {
    mode: ThemeModeValues;
    custom: AnyObject;
    shape: {
        borderRadius: number;
        spacing: number;
        gap: number;
    };
    typography: {
        fontSize: number;
        lineHeight: number;
    };
    colors: {
        primary: ThemeColorsProps;
        secondary: ThemeColorsProps;
        info: ThemeColorsProps;
        success: ThemeColorsProps;
        warning: ThemeColorsProps;
        error: ThemeColorsProps;
        gray: ThemeColorsProps;
        red: ThemeColorsProps;
        orange: ThemeColorsProps;
        amber: ThemeColorsProps;
        yellow: ThemeColorsProps;
        lime: ThemeColorsProps;
        green: ThemeColorsProps;
        teal: ThemeColorsProps;
        cyan: ThemeColorsProps;
        blue: ThemeColorsProps;
        indigo: ThemeColorsProps;
        violet: ThemeColorsProps;
        purple: ThemeColorsProps;
        fuchsia: ThemeColorsProps;
        pink: ThemeColorsProps;
        common: {
            transparent: string;
            black: string;
            white: string;
            /** Alias for "transparent" */
            trans: string;
        };
        text: {
            primary: string;
            secondary: string;
            disabled: string;
        };
        background: {
            primary: string;
            secondary: string;
            disabled: string;
        };
        [key: string]: ThemeColorsProps | any;
    };
    mixins: {
        transitions: {
            slow: AnyObject;
            medium: AnyObject;
            fast: AnyObject;
        };
        scroll: AnyObject;
        /** Global CSS for WEB only */
        globalCSS: string;
        zIndex: {
            backdrop: number;
            modal: number;
            dropdown: number;
            tooltip: number;
            toaster: number;
        };
    };
    breakpoints: RbkBreakpoints;
    rem: (multiplier?: number, base?: number | null) => number;
    spacing: (multiplier?: number) => number;
    color: (color: RbkColor, alpha?: `${number}%` | number | null, luminosity?: `${number}%` | number | null) => string;
    contrast: (color: RbkColor, lightColor?: string | null, darkColor?: string | null) => string;
    components: {
        Avatar: ThemeComponentProps<AvatarProps>;
        Backdrop: ThemeComponentProps<BackdropProps>;
        Badge: ThemeComponentProps<BadgeProps>;
        Box: ThemeComponentProps<BoxProps>;
        Button: ThemeComponentProps<ButtonProps>;
        ButtonGroup: ThemeComponentProps<ButtonGroupProps>;
        Calendar: ThemeComponentProps<CalendarProps>;
        Card: ThemeComponentProps<CardProps>;
        Carousel: ThemeComponentProps<CarouselProps>;
        Checkbox: ThemeComponentProps<CheckboxProps>;
        Collapse: ThemeComponentProps<CollapseProps>;
        Divider: ThemeComponentProps<DividerProps>;
        Drawer: ThemeComponentProps<DrawerProps>;
        Dropdown: ThemeComponentProps<DropdownProps>;
        Form: ThemeComponentProps<FormProps>;
        Grid: ThemeComponentProps<GridProps>;
        GrowBox: ThemeComponentProps<GrowBoxProps>;
        Image: ThemeComponentProps<ImageProps>;
        InputBase: ThemeComponentProps<InputBaseProps>;
        Input: ThemeComponentProps<InputProps>;
        InputDate: ThemeComponentProps<InputDateProps>;
        InputPin: ThemeComponentProps<InputPinProps>;
        Label: ThemeComponentProps<LabelProps>;
        Link: ThemeComponentProps<LinkProps>;
        List: ThemeComponentProps<ListProps>;
        ListItem: ThemeComponentProps<ListItemProps>;
        Loading: ThemeComponentProps<LoadingProps>;
        Modal: ThemeComponentProps<ModalProps>;
        Outline: ThemeComponentProps<OutlineProps>;
        Progress: ThemeComponentProps<ProgressProps>;
        Resizable: ThemeComponentProps<ResizableProps>;
        Scrollable: ThemeComponentProps<ScrollableProps>;
        Select: ThemeComponentProps<SelectProps>;
        Switch: ThemeComponentProps<SwitchProps>;
        Splitter: ThemeComponentProps<SplitterProps>;
        Table: ThemeComponentProps<TableProps>;
        Tabs: ThemeComponentProps<TabsProps>;
        Terminal: ThemeComponentProps<TerminalProps>;
        Text: ThemeComponentProps<TextProps>;
        Toaster: ThemeComponentProps<ToasterProps>;
        Tooltip: ThemeComponentProps<TooltipProps>;
    };
};
type ThemeEditProps = RecursivePartial<ThemeProps>;
type RbkTheme = ThemeProps & {
    setTheme: (value: ThemeModeValues | ThemeEditProps | ((theme: ThemeProps) => ThemeEditProps)) => any;
};
type AccessibilityProps = {
    accessible?: boolean;
    hint?: string;
    label?: string;
    role?: 'adjustable' | 'alert' | 'button' | 'checkbox' | 'combobox' | 'grid' | 'header' | 'image' | 'imagebutton' | 'keyboardkey' | 'link' | 'menu' | 'menubar' | 'menuitem' | 'none' | 'progressbar' | 'radio' | 'radiogroup' | 'scrollbar' | 'search' | 'spinbutton' | 'summary' | 'switch' | 'tab' | 'tablist' | 'text' | 'timer' | 'togglebutton' | 'toolbar';
    state?: {
        checked?: boolean | any;
        disabled?: boolean;
        expanded?: boolean;
        selected?: boolean;
        busy?: boolean;
    };
    value?: {
        max?: number;
        min?: number;
        now?: number;
        text?: string;
    };
};
type PressableProps = {
    pressable?: boolean;
    onPress?: (event: RbkPointerEvent) => void;
    onPressIn?: (event: RbkPointerEvent) => void;
    onPressOut?: (event: RbkPointerEvent) => void;
    onLongPress?: (event: RbkPointerEvent) => void;
    /** @deprecated use onPress(event) instead */
    onClick?: (event: RbkPointerEvent) => void;
    /** @deprecated use onPressIn(event) instead */
    onMouseDown?: (event: RbkPointerEvent) => void;
    /** @deprecated use onPressOut(event) instead */
    onMouseUp?: (event: RbkPointerEvent) => void;
};
type FocusableProps = {
    autoFocus?: boolean;
    blur?: () => void;
    focus?: () => void;
    isFocused?: () => boolean;
    onBlur?: (event: RbkEvent) => void;
    onFocus?: (event: RbkEvent) => void;
    onKeyPress?: (event: RbkKeyboardEvent) => void;
    onKeyDown?: (event: RbkKeyboardEvent) => void;
    onKeyUp?: (event: RbkKeyboardEvent) => void;
};
type BaseProps = Overwrite<PressableProps, Overwrite<StyleProps, {
    ref?: Ref<any>;
    children?: ReactElement | any;
    id?: string;
    className?: any;
    platform?: object;
    accessibility?: AccessibilityProps;
    invisible?: boolean;
    hidden?: boolean | {
        [key in keyof RbkBreakpoints]?: boolean;
    };
    mount?: boolean;
    component?: any;
    componentProps?: AnyObject;
    noRootStyles?: boolean;
    style?: RbkStyle;
    rawStyle?: RbkStyle;
    animation?: RbkAnimation & {
        onStart?: () => void;
        onEnd?: () => void;
    };
    row?: boolean;
    column?: boolean;
    reverse?: boolean;
    wrap?: boolean | 'wrap' | 'nowrap' | 'wrap-reverse';
    noWrap?: boolean;
    center?: boolean;
    flex?: boolean;
    xs?: 'auto' | 'flex' | 'hide' | (number & {}) | (boolean | {});
    sm?: 'auto' | 'flex' | 'hide' | (number & {}) | (boolean | {});
    md?: 'auto' | 'flex' | 'hide' | (number & {}) | (boolean | {});
    lg?: 'auto' | 'flex' | 'hide' | (number & {}) | (boolean | {});
    xl?: 'auto' | 'flex' | 'hide' | (number & {}) | (boolean | {});
    xxl?: 'auto' | 'flex' | 'hide' | (number & {}) | (boolean | {});
}>>;
type BoxProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {}>;
type TextProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    variant?: 'h1' | 'h2' | 'h3' | 'h4' | 'h5' | 'h6' | 'title' | 'subtitle' | 'primary' | 'secondary' | 'caption';
    size?: number;
    color?: RbkColor;
    center?: boolean;
    left?: boolean;
    right?: boolean;
    justify?: boolean;
    bold?: boolean;
    italic?: boolean;
    selectable?: boolean;
    smallCaps?: boolean;
    weight?: 'normal' | 'bold' | '100' | '200' | '300' | '400' | '500' | '600' | '700' | '800' | '900' | (string & {});
    transform?: 'none' | 'capitalize' | 'uppercase' | 'lowercase' | 'full-width';
    numberOfLines?: number;
    variants?: {
        root?: any;
    };
}>;
type LabelProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, TextProps<false>, {
    for?: string;
    forRef?: RefObject<ReactElement>;
    variants?: {
        root?: any;
    };
}>;
type ButtonProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, FocusableProps, {
    badge?: number | BadgeProps;
    circular?: boolean;
    color?: RbkColor;
    contrastColor?: RbkColor;
    disabled?: boolean;
    disabledColor?: RbkColor;
    endAddon?: ReactElement | ((options: {
        color: RbkColor;
    }) => ReactElement);
    href?: string;
    label?: string;
    loading?: boolean;
    size?: RbkSize;
    startAddon?: ReactElement | ((options: {
        color: RbkColor;
    }) => ReactElement);
    transform?: 'none' | 'capitalize' | 'uppercase' | 'lowercase' | 'full-width';
    type?: 'button' | 'submit' | 'cancel' | 'reset' | 'clear';
    variant?: 'solid' | 'outline' | 'text';
    contentStyle?: RbkStyle;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        label?: any;
    };
}>;
type ButtonGroupProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    color?: RbkColor;
    disabled?: boolean;
    loading?: boolean;
    size?: RbkSize;
    variant?: 'solid' | 'outline' | 'text';
    contentStyle?: RbkStyle;
    variants?: {
        root?: any;
        content?: any;
    };
}>;
type InputBaseProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, FocusableProps, {
    autoCapitalize?: 'none' | 'sentences' | 'words' | 'characters';
    autoComplete?: 'off' | 'additional-name' | 'address-line1' | 'address-line2' | 'cc-number' | 'country' | 'current-password' | 'email' | 'family-name' | 'given-name' | 'honorific-prefix' | 'honorific-suffix' | 'name' | 'new-password' | 'one-time-code' | 'postal-code' | 'street-address' | 'tel' | 'username' | (string & {});
    autoCorrect?: boolean;
    caretHidden?: boolean;
    color?: RbkColor;
    colorful?: boolean;
    controlled?: boolean;
    defaultValue?: InputValue;
    disabled?: boolean;
    endAddon?: ReactElement | ((options: {
        color: RbkColor;
    }) => ReactElement);
    error?: string | boolean | null | undefined;
    hint?: string;
    inputMode?: 'none' | 'text' | 'decimal' | 'numeric' | 'tel' | 'search' | 'email' | 'url' | (string & {});
    label?: string;
    multiline?: boolean;
    name?: string;
    placeholder?: string;
    placeholderColor?: RbkColor;
    readOnly?: boolean;
    returnKeyType?: 'default' | 'done' | 'go' | 'next' | 'search' | 'send';
    rows?: number;
    secure?: boolean;
    selectionColor?: RbkColor;
    selectTextOnFocus?: boolean;
    size?: RbkSize;
    startAddon?: ReactElement | ((options: {
        color: RbkColor;
    }) => ReactElement);
    textColor?: RbkColor;
    type?: 'text' | 'number' | 'password' | 'email' | 'phone' | 'url' | 'hidden' | (string & {});
    value?: InputValue;
    contentStyle?: RbkStyle;
    hintStyle?: RbkStyle;
    errorStyle?: RbkStyle;
    labelStyle?: RbkStyle;
    inputStyle?: RbkStyle;
    variants?: {
        root: any;
        content: any;
        label: any;
        input: any;
        hint: any;
        error: any;
    };
}>;
type InputProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, InputBaseProps<false>, {
    mask?: (value: InputValue) => any;
    max?: number;
    maxLength?: number;
    min?: number;
    notNull?: boolean;
    unmask?: (value: InputValue) => any;
    onFocus?: (event: RbkInputEvent, value: InputValue) => void;
    onBlur?: (event: RbkInputEvent, value: InputValue) => void;
    onSubmit?: (event: RbkInputEvent, value: InputValue) => void;
    onChange?: (event: RbkInputEvent, value: InputValue) => void;
    onFormChange?: (event: RbkFormEvent, data: AnyObject) => void;
    variants?: {
        root: any;
        content: any;
        label: any;
        input: any;
        hint: any;
        error: any;
    };
}>;
type SelectProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, ButtonProps<false>, {
    colorful?: boolean;
    controlled?: boolean;
    defaultValue?: InputValue;
    error?: string | boolean | null | undefined;
    label?: string;
    name?: string;
    options?: SelectOption[];
    placeholder?: string;
    readOnly?: boolean;
    searchCount?: number;
    value?: InputValue;
    onFocus?: (event: RbkInputEvent, value: InputValue, option?: SelectOption | null) => void;
    onBlur?: (event: RbkInputEvent, value: InputValue, option?: SelectOption | null) => void;
    onChange?: (event: RbkInputEvent, value: InputValue, option?: SelectOption | null) => any;
    onFormChange?: (event: RbkFormEvent, data: AnyObject) => any;
    buttonStyle?: RbkStyle;
    errorStyle?: RbkStyle;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        label?: any;
        error?: any;
    };
}>;
type CheckboxProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, ButtonProps<false>, {
    checked?: boolean;
    color?: RbkColor;
    controlled?: boolean;
    defaultChecked?: boolean;
    disabled?: boolean;
    error?: string | boolean | null | undefined;
    label?: ReactElement;
    name?: string;
    readOnly?: boolean;
    size?: RbkSize;
    unique?: boolean;
    value?: InputValue;
    onFocus?: (event: RbkInputEvent, checked: boolean) => void;
    onBlur?: (event: RbkInputEvent, checked: boolean) => void;
    onChange?: (event: RbkInputEvent, checked: boolean) => any;
    onFormChange?: (event: RbkFormEvent, data: AnyObject) => any;
    buttonStyle?: RbkStyle;
    errorStyle?: RbkStyle;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        button?: any;
        label?: any;
        error?: any;
    };
}>;
type SwitchProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, ButtonProps<false>, {
    checked?: boolean;
    controlled?: boolean;
    defaultChecked?: boolean;
    disabled?: boolean;
    error?: string | boolean | null | undefined;
    label?: ReactElement;
    name?: string;
    readOnly?: boolean;
    size?: RbkSize;
    onColor?: RbkColor;
    offColor?: RbkColor;
    onThumbColor?: RbkColor;
    offThumbColor?: RbkColor;
    onFocus?: (event: RbkInputEvent, checked: boolean) => void;
    onBlur?: (event: RbkInputEvent, checked: boolean) => void;
    onChange?: (event: RbkInputEvent, checked: boolean) => any;
    onFormChange?: (event: RbkFormEvent, data: AnyObject) => any;
    buttonStyle?: RbkStyle;
    thumbStyle?: RbkStyle;
    errorStyle?: RbkStyle;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        button?: any;
        label?: any;
        thumb?: any;
        error?: any;
    };
}>;
type CardProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    variants?: {
        root?: any;
    };
}>;
type CarouselProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    chevron?: boolean | 'visible' | 'hidden' | ((options: {
        prev: boolean;
        next: boolean;
        color: RbkColor;
        onPress: () => void;
    }) => ReactElement);
    color?: RbkColor;
    gap?: GridProps<false>['gap'];
    pagingEnabled?: boolean;
    pointerScroll?: boolean;
    xs?: number | 'auto' | RbkStyle;
    sm?: number | 'auto' | RbkStyle;
    md?: number | 'auto' | RbkStyle;
    lg?: number | 'auto' | RbkStyle;
    xl?: number | 'auto' | RbkStyle;
    itemStyle?: RbkStyle;
    chevronStyle?: {
        color?: RbkColor;
        size?: number;
    } & RbkStyle;
    variants?: {
        root?: any;
        content?: any;
        chevron?: any;
    };
}>;
type InputDateProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, InputProps<false>, {
    locale?: Intl.LocalesArgument;
    format?: {
        month?: 'long' | 'narrow' | 'numeric' | 'short' | '2-digit';
        day?: 'numeric' | '2-digit';
        year?: 'numeric' | '2-digit';
    };
    max?: Date | string | number | null | undefined;
    min?: Date | string | number | null | undefined;
    value?: Date | string | number | null | undefined;
    variant?: 'modal' | 'inline' | 'dropdown';
    translate?: {
        cancel?: string;
        clear?: string;
        today?: string;
    };
}>;
type ScrollableProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    contentInset?: RbkUnit | {
        vertical?: RbkUnit;
        horizontal?: RbkUnit;
        top?: RbkUnit;
        bottom?: RbkUnit;
        left?: RbkUnit;
        right?: RbkUnit;
    };
    direction?: 'vertical' | 'horizontal';
    hideScrollBar?: boolean;
    /** Note: vertical pagination is not supported on Android. **/
    pagingEnabled?: boolean;
    onScroll?: (event: RbkScrollEvent) => void;
    contentStyle?: RbkStyle;
    variants?: {
        root?: any;
        content?: any;
    };
}>;
type ImageProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    source: {
        uri?: string;
    } | (string & {}) | (number & {});
    alt?: string;
    circular?: boolean;
    fallback?: ReactElement;
    mode?: 'cover' | 'contain' | 'fill';
    width?: number | string;
    height?: number | string;
    onLoad?: Function;
    onError?: Function;
    variants?: {
        root?: any;
    };
}>;
type DividerProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    color?: RbkColor;
    opacity?: number;
    size?: number | string;
    vertical?: boolean;
    variants?: {
        root?: any;
    };
}>;
type BackdropProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    keepMounted?: boolean;
    visible?: boolean;
    variants?: {
        root?: any;
    };
}>;
type ModalProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    keepMounted?: boolean;
    animation?: 'fade' | 'zoom-in' | 'zoom-out' | 'slide-bottom' | 'slide-top' | 'slide-left' | 'slide-right';
    halign?: 'center' | 'left' | 'right';
    valign?: 'center' | 'top' | 'bottom';
    visible?: boolean;
    onClose?: PressableProps['onPress'];
    variants?: {
        root?: any;
        backdrop?: any;
    };
}>;
type CollapseProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, Pick<RbkAnimation, 'delay' | 'duration' | 'timing'>, {
    visible?: boolean;
    variants?: {
        root?: any;
    };
}>;
type DropdownProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    keepMounted?: boolean;
    placement?: 'top' | 'bottom';
    triggerRef?: RefObject<ReactElement>;
    visible?: boolean;
    onClose?: PressableProps['onPress'];
    variants?: {
        root?: any;
        backdrop?: any;
    };
}>;
type LoadingProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    color?: RbkColor;
    duration?: number;
    label?: string;
    size?: RbkSize;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        label?: any;
    };
}>;
type GridProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    breakpoints?: Partial<RbkBreakpoints>;
    gap?: number | true;
    size?: number;
    variants?: {
        root?: any;
        item?: any;
    };
}>;
type TableProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    columns: TableColumn[];
    rows?: any[] | any;
    variants?: {
        root?: any;
    };
}>;
type BadgeProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    value?: number;
    size?: RbkSize;
    dot?: boolean;
    top?: boolean;
    bottom?: boolean;
    left?: boolean;
    right?: boolean;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        label?: any;
    };
}>;
type FormProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    disableObjectParser?: boolean;
    initialData?: AnyObject;
    onSubmit?: (event: RbkFormEvent, data: AnyObject, errors: AnyObject | null) => void;
    onCancel?: (event: RbkFormEvent, data: AnyObject, errors: AnyObject | null) => void;
    onReset?: (event: RbkFormEvent, data: AnyObject, errors: AnyObject | null) => void;
    onClear?: (event: RbkFormEvent, data: AnyObject, errors: AnyObject | null) => void;
    onChange?: (event: RbkFormEvent, data: AnyObject, errors: AnyObject | null) => void;
    variants?: {
        root?: any;
    };
}>;
type TooltipProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    color?: 'black' | 'white' | RbkColor;
    delay?: number;
    offset?: number | string;
    position?: 'top' | 'bottom' | 'left' | 'right';
    title?: string;
    visible?: boolean;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        label?: any;
    };
}>;
type ProgressProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    color?: RbkColor;
    label?: boolean | ((value: number) => ReactElement);
    size?: RbkSize;
    value?: number;
    barStyle?: RbkStyle;
    labelStyle?: RbkStyle;
    variants?: {
        root?: any;
        bar?: any;
        label?: any;
    };
}>;
type ListItemProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    chevron?: boolean | ReactElement;
    endAddon?: ReactElement;
    gap?: GridProps<false>['gap'];
    startAddon?: ReactElement;
    chevronStyle?: Overwrite<RbkStyle, {
        size?: number;
        color?: RbkColor;
    }>;
    variants?: {
        root?: any;
    };
}>;
type LinkProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, TextProps<false>, {
    underline?: boolean;
    variants?: {
        root?: any;
    };
}>;
type DrawerProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    keepMounted?: boolean;
    placement?: 'left' | 'right' | 'top' | 'bottom';
    visible?: boolean;
    backdropStyle?: RbkStyle;
    variants?: {
        root?: any;
        backdrop?: any;
    };
}>;
type OutlineProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    color?: RbkColor;
    size?: number;
    visible?: 'auto' | boolean;
    variants?: {
        root?: any;
    };
}>;
type TabsProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, BoxProps<false>, {
    alignment?: 'start' | 'center' | 'end';
    circular?: boolean;
    color?: RbkColor;
    size?: RbkSize;
    tabs: TabItem[];
    value?: string | number;
    variant?: 'group' | 'card' | 'nav';
    onChange?: (event: RbkPointerEvent, value: string | number) => any;
    contentStyle?: RbkStyle;
    buttonStyle?: RbkStyle;
    activeStyle?: RbkStyle;
    variants?: {
        root?: any;
        content?: any;
        button?: any;
        active?: any;
    };
}>;
type ToasterProps = {
    content?: ReactElement;
    color?: RbkColor;
    duration?: number;
    halign?: 'left' | 'right' | 'center';
    offset?: {
        x?: number | string;
        y?: number | string;
    };
    valign?: 'top' | 'bottom';
    width?: number | string;
    onPress?: PressableProps['onPress'];
    variants?: {
        root?: any;
    };
};
type CalendarProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    color?: RbkColor;
    date?: Date | string | number | null | undefined;
    disableds?: (Date | string | number)[] | ((date: Date) => boolean);
    events?: (Date | string | number)[];
    onPressDate?: (event: AnyObject, date: Date) => any;
    variants?: {
        root?: any;
    };
}>;
type AvatarProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    alt?: string;
    color?: RbkColor;
    corners?: number;
    placeholder?: ReactElement;
    size?: number;
    source?: {
        uri?: string;
    } | (string & {}) | (number & {});
    contentStyle?: RbkStyle;
    variants?: {
        root?: any;
        content?: any;
    };
}>;
type TerminalProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, ScrollableProps<false>, {
    prompt?: string;
    version?: string;
    welcomeMessage?: string;
    commands?: {
        [key: string]: string | (() => Promise<string | void>);
    }[];
    variants?: {
        root?: any;
    };
}>;
type ListProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, ScrollableProps<false>, {
    renderDelay?: number;
    renderOffset?: number;
    rowHeight?: number;
    rowWidth?: number;
    rowFallbackComponent?: JSXElementConstructor<any> | string;
    variants?: {
        root?: any;
    };
}>;
type InputPinProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, Pick<InputProps<false>, 'autoFocus' | 'color' | 'colorful' | 'defaultValue' | 'disabled' | 'name' | 'notNull' | 'placeholder' | 'placeholderColor' | 'readOnly' | 'returnKeyType' | 'secure' | 'size' | 'textColor' | 'value' | 'inputStyle' | 'variants' | 'onChange' | 'onSubmit' | 'onFormChange'>, {
    length?: number;
    type?: 'alphanumeric' | 'alphabetic' | 'numeric';
}>;
type GrowBoxProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    duration?: number;
    variants?: {
        root?: any;
    };
}>;
type ResizableProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    horizontal?: boolean;
    vertical?: boolean;
    variants?: {
        root?: any;
    };
}>;
type SplitterProps<ALLOW_ANY = true> = PropsWithStyles<ALLOW_ANY, {
    direction?: 'vertical' | 'horizontal';
    variants?: {
        root?: any;
        item?: any;
    };
}>;

declare const useForm: () => FormRef;
declare const FormFactory: React__default.NamedExoticComponent<FormProps>;

declare function useAnimation(style?: RbkAnimation['from'], ref?: MutableRefObject<any>): {
    start: (options: RbkAnimation) => Promise<unknown>;
    stop: () => void;
    reset: () => void;
    props: {
        ref: MutableRefObject<any>;
        style: RbkStyleProps | undefined;
    };
};

declare function useBreakpoints(breakpoints?: Partial<ThemeProps['breakpoints']>): {
    [k: string]: boolean;
};

declare function useDefaultRef<T = undefined>(ref: any, initialValue?: T | null): React.MutableRefObject<T>;

declare function useDeferredValue<T>(value: T, initialValue?: T, delayMs?: number): T | undefined;

declare function useDependentState<T>(factory: (current?: T) => T, deps: unknown[]): readonly [T, React.Dispatch<React.SetStateAction<T>>];

type UseDraggableProps = {
    onDragStart?: (event: RbkPointerEvent) => void;
    onDragMove?: (event: RbkPointerEvent) => void;
    onDragEnd?: (event: RbkPointerEvent) => void;
};
declare function useDraggable({ onDragStart, onDragMove, onDragEnd }?: UseDraggableProps): {
    capture: () => void;
    release: () => void;
    isCapturing: boolean;
};

declare function useHtmlId(id?: string): string;

type UseInputProps<T> = {
    prop?: string;
    name?: string;
    value?: T;
    defaultValue?: T;
    controlled?: boolean;
    editable?: boolean;
    error?: string | boolean | null | undefined;
    mask?: (value: T) => string;
    unmask?: (value: T) => T;
    onChange?: (event: any, value: T, ...rest: any[]) => void;
    onFormChange?: (event: RbkFormEvent, data: AnyObject) => void;
};
declare function useInput<T>({ prop, name, value, defaultValue, controlled, editable, error: errorProp, mask, unmask, onChange, onFormChange, }: UseInputProps<T>): {
    state: any;
    setState: (value: any, event?: Event, ...rest: any[]) => void;
    prevState: any;
    error: string | true | null;
    clear: () => void;
    reset: () => void;
    form: FormRef;
    props: {
        name: string | undefined;
        value: string;
        onChange: (event: any) => void;
    };
};

declare function usePropState<T>(prop: T | undefined, initialState?: T | (() => T)): readonly [T, React.Dispatch<React.SetStateAction<T>>];

declare function useTheme(): RbkTheme;

declare function useToaster(): {
    open: (options: string | ToasterProps) => void;
    close: () => void;
    info: (options: string | Omit<ToasterProps, "color">) => void;
    success: (options: string | Omit<ToasterProps, "color">) => void;
    warning: (options: string | Omit<ToasterProps, "color">) => void;
    error: (options: string | Omit<ToasterProps, "color">) => void;
    primary: (options: string | Omit<ToasterProps, "color">) => void;
    secondary: (options: string | Omit<ToasterProps, "color">) => void;
};

declare function export_default$1({ ...props }: any): any;

declare function childrenize(children: any): ReactElement$1<any, string | React.JSXElementConstructor<any>>[];

declare function extract(props: string | string[], ...mixin: any[]): AnyObject;

declare function get<T = any>(prop: string, ...mixin: unknown[]): T | undefined;

declare function getSize(value?: RbkSize): number;

declare function merge(...mixin: unknown[]): any;

declare function omit(props: string | string[], ...mixin: AnyObject[]): AnyObject;

declare function only(props: string | string[], ...mixin: AnyObject[]): {};

declare function remove(props: string | string[], ...mixin: unknown[]): void;

declare function getFullHeight($el: any): Promise<number>;

declare function getFullSize($el: any): Promise<RbkRect>;

declare function rect($el: any): Promise<RbkRect>;

declare function reference(ref: any, mirrorRef?: any): any;

declare function scrollIntoView($scrollableEl: any, $targetEl: any, animated?: boolean): void;

declare function scrollTo($el: any, x?: number, y?: number, animated?: boolean): void;

declare function scrollToEnd($el: any, animated?: boolean): void;

declare function scrollToStart($el: any, animated?: boolean): void;

declare function setNativeStyle($el: any, styles: RbkStyle): void;

declare function base(event: any, extra?: Record<PropertyKey, unknown>): RbkEvent;

declare function keyboard(event: any, extra?: Record<PropertyKey, unknown>): RbkKeyboardEvent;

declare function pointer(event: any, extra?: Record<PropertyKey, unknown>): RbkPointerEvent;

declare const Platform: {
    web: boolean;
    native: boolean;
    server: boolean;
};

declare function clone(mixin: any): {};

declare function export_default(...args: any): string;

declare function crypt(str: string): string;

declare function deepmerge(...mixed: any[]): (typeof mixed)[0];

declare function defined(value: unknown): boolean;

declare function event($el: any, event: any, callback: any, options?: any): () => any;

declare const rbkGlobal: AnyObject;

declare function pick(option: string, defaultOption: string, options?: object): any;

declare function sleep(ms: any): Promise<unknown>;

declare const stdout: {
    log(...args: any[]): void;
    error(...args: any[]): void;
    warn(...args: any[]): void;
};

declare function string(value: any): string;

declare function uuid(): string;

declare function css(...mixin: (string | RbkStyle)[]): string;

declare function jss(...mixin: (string | RbkStyle)[]): {
    [key: string]: any;
};

declare function sheet(...mixin: (string | RbkStyle)[]): string;

declare function createMeta(selector: string, props: object, overwrite?: boolean): any;

declare function createPortal(key: string, children?: ReactElement): react_jsx_runtime.JSX.Element;

declare function createTheme(options?: ThemeEditProps): ThemeProps;

declare const AvatarFactory: React__default.NamedExoticComponent<AvatarProps>;

declare const BackdropFactory: React__default.NamedExoticComponent<BackdropProps>;

declare const BadgeFactory: React__default.NamedExoticComponent<BadgeProps>;

declare const BoxFactory: React__default.NamedExoticComponent<BoxProps>;

declare const ButtonFactory: React__default.NamedExoticComponent<ButtonProps>;

declare const ButtonGroupFactory: React__default.NamedExoticComponent<ButtonGroupProps>;

declare const CalendarFactory: React__default.NamedExoticComponent<CalendarProps>;

declare const CardFactory: React__default.NamedExoticComponent<CardProps>;

declare const CarouselFactory: React__default.NamedExoticComponent<CarouselProps>;

declare const CheckboxFactory: React__default.NamedExoticComponent<CheckboxProps>;

declare const CollapseFactory: React__default.NamedExoticComponent<CollapseProps>;

declare const InputDateFactory: React__default.NamedExoticComponent<InputDateProps>;

declare const DividerFactory: React__default.NamedExoticComponent<DividerProps>;

declare const DrawerFactory: React__default.NamedExoticComponent<DrawerProps>;

declare const DropdownFactory: React__default.NamedExoticComponent<DropdownProps>;

declare const GridFactory: React__default.NamedExoticComponent<GridProps>;

declare const GrowBoxFactory: React__default.NamedExoticComponent<GrowBoxProps>;

declare const ImageFactory: React__default.NamedExoticComponent<ImageProps>;

declare const InputBaseFactory: React__default.NamedExoticComponent<InputBaseProps>;

declare const InputFactory: React__default.NamedExoticComponent<InputProps>;

declare const InputPinFactory: React__default.NamedExoticComponent<InputPinProps>;

declare const LabelFactory: React__default.NamedExoticComponent<LabelProps>;

declare const LinkFactory: React__default.NamedExoticComponent<LinkProps>;

declare const ListFactory: React__default.NamedExoticComponent<ListProps>;

declare const ListItemFactory: React__default.NamedExoticComponent<ListItemProps>;

declare const LoadingFactory: React__default.NamedExoticComponent<LoadingProps>;

declare const ModalFactory: React__default.NamedExoticComponent<ModalProps>;

declare const OutlineFactory: React__default.NamedExoticComponent<OutlineProps>;

declare const ProgressFactory: React__default.NamedExoticComponent<ProgressProps>;

declare const ResizableFactory: React__default.NamedExoticComponent<ResizableProps>;

declare const ScrollableFactory: React__default.NamedExoticComponent<ScrollableProps>;

declare const SelectFactory: React__default.NamedExoticComponent<SelectProps>;

declare const SplitterFactory: React__default.NamedExoticComponent<SplitterProps>;

declare const SwitchFactory: React__default.NamedExoticComponent<SwitchProps>;

declare const TableFactory: React__default.NamedExoticComponent<TableProps>;

declare const TabsFactory: React__default.NamedExoticComponent<TabsProps>;

declare const TerminalFactory: React__default.NamedExoticComponent<TerminalProps>;

declare const TextFactory: React__default.NamedExoticComponent<TextProps>;

declare const TooltipFactory: React__default.NamedExoticComponent<TooltipProps>;

export { type AccessibilityProps, type AnyObject, AvatarFactory, type AvatarProps, BackdropFactory, type BackdropProps, BadgeFactory, type BadgeProps, type BaseProps, BoxFactory, type BoxProps, ButtonFactory, ButtonGroupFactory, type ButtonGroupProps, type ButtonProps, CalendarFactory, type CalendarProps, CardFactory, type CardProps, CarouselFactory, type CarouselProps, CheckboxFactory, type CheckboxProps, CollapseFactory, type CollapseProps, type DistributiveOmit, DividerFactory, type DividerProps, DrawerFactory, type DrawerProps, DropdownFactory, type DropdownProps, type FocusableProps, FormFactory, type FormField, type FormProps, type FormRef, GridFactory, type GridProps, GrowBoxFactory, type GrowBoxProps, ImageFactory, type ImageProps, InputBaseFactory, type InputBaseProps, InputDateFactory, type InputDateProps, InputFactory, InputPinFactory, type InputPinProps, type InputProps, type InputValue, type IntervalType, LabelFactory, type LabelProps, LinkFactory, type LinkProps, ListFactory, ListItemFactory, type ListItemProps, type ListProps, LoadingFactory, type LoadingProps, ModalFactory, type ModalProps, OutlineFactory, type OutlineProps, type Overwrite, Platform, type PressableProps, type Prettify, ProgressFactory, type ProgressProps, type RbkAnimation, type RbkBreakpoints, type RbkColor, type RbkEvent, type RbkFormEvent, type RbkInputEvent, type RbkKeyboardEvent, type RbkMap, type RbkPointerEvent, type RbkRect, type RbkScrollEvent, type RbkSize, type RbkStyle, type RbkStyleProps, type RbkTheme, type RbkTouch, type RbkUnit, ReactBulk, type ReactElement, type ReactOnlyElement, type RecursivePartial, type RequiredSome, ResizableFactory, type ResizableProps, ScrollableFactory, type ScrollableProps, SelectFactory, type SelectOption, type SelectProps, SplitterFactory, type SplitterProps, SwitchFactory, type SwitchProps, type TabItem, type TableColumn, TableFactory, type TableProps, TabsFactory, type TabsProps, TerminalFactory, type TerminalProps, TextFactory, type TextProps, type ThemeColorsProps, type ThemeComponentProps, type ThemeEditProps, type ThemeModeValues, type ThemeProps, type TimeoutType, type ToasterProps, TooltipFactory, type TooltipProps, aliases, base as baseEvent, export_default$1 as bindings, boxSizeProps, childrenize, clone, export_default as clsx, createMeta, createPortal, createTheme, crypt, css, customSpacings, customStyleProps, deepmerge, defined, event, extract, flexAlignProps, flexChildAlignProps, flexChildProps, flexContainerAlignProps, flexContainerProps, flexProps, gapSpacings, get, getFullHeight, getFullSize, getSize, rbkGlobal as global, jss, keyboard as keyboardEvent, merge, notPxProps, omit, only, pick, pointer as pointerEvent, rect, reference, remove, scrollIntoView, scrollTo, scrollToEnd, scrollToStart, setNativeStyle, sheet, sleep, spacings, stdout, string, styleProps, transformProps, useAnimation, useBreakpoints, useDefaultRef, useDeferredValue, useDependentState, useDraggable, useForm, useHtmlId, useInput, usePropState, useTheme, useToaster, uuid };
